/*-
 * Copyright (c)2007 Takuya SHIOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef OBS_DEFINES_H_
#define OBS_DEFINES_H_

#ifdef __cplusplus
#define OBS_BEGIN_DECL_		extern "C" {
#define OBS_END_DECL_		}
#else
#define OBS_BEGIN_DECL_
#define OBS_END_DECL_
#endif

#define OBS_DEF_INLINE_FUNC_(ret, name, args)				      \
static __inline ret name args __attribute__((always_inline));		      \
ret name args

#define OBS_STRUCT_INIT_(name, value)					      \
	.name = (value)

#define OBS_ARRAY_INIT_(suf, value)					      \
	[(suf)] = (value)

#define OBS_NUM_OF(array)						      \
	(sizeof (array) / sizeof (array[0]))

#define OBS_LEAST_MAX_ALIGNMENT		8

#define OBS_ALIGN_1		0
#define OBS_ALIGN_2		1
#define OBS_ALIGN_4		2
#define OBS_ALIGN_8		3
#define OBS_ALIGN_16		4
#define OBS_ALIGN_32		5
#define OBS_ALIGN_64		6
#define OBS_ALIGN_128		7
#define OBS_ALIGN_256		8

#endif
