/*-
 * Copyright (c)2007 Takuya SHIOZAKI,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <obs/obs_status.h>

const char *
obs_strstatus(OBS_status st)
{
	static const char * const mes[] = {
		OBS_ARRAY_INIT_(OBS_S_NOERR, "no error"),
		OBS_ARRAY_INIT_(OBS_S_NOMEM, "no memory"),
		OBS_ARRAY_INIT_(OBS_S_CANNOT_EXPAND, "cannot expand"),
		OBS_ARRAY_INIT_(OBS_S_INVAL, "invalid argument"),
		OBS_ARRAY_INIT_(OBS_S_NOTSUPP, "not supported"),
		OBS_ARRAY_INIT_(OBS_S_NOT_CONTIGUOUS, "not contiguous"),
		OBS_ARRAY_INIT_(OBS_S_TOO_BIG, "too big"),
		OBS_ARRAY_INIT_(OBS_S_REVOKED, "unintentional revocation"),
		OBS_ARRAY_INIT_(OBS_S_UNKNOWN, "unknown status")
	};

	if (st<0 || st>=OBS_NUM_OF(mes))
		return mes[OBS_S_UNKNOWN];

	return mes[st];
}
