#include <obs/obs.h>
#include <stdio.h>
#include <stdlib.h>

static void error(const char *, OBS_status);

int
main()
{
	OBS_status ret;
	OBS_stack obs;
	OBS_size size;
	const OBS_region *top;
	int ch;

	ret = obs_stack_init(&obs, 1, 0, OBS_ALIGN_4);
	if (ret)
		error("obs_stack_init", ret);

	size = 0;
	top = obs_stack_get_top(&obs);
	ret = obs_stack_alloc(&obs, size);
	if (ret)
		error("obs_stack_alloc", ret);

	while ((ch = getchar()) != EOF) {
		ret = obs_stack_resize_top(&obs, size + 1);
		if (ret)
			error("obs_stack_resize_top", ret);
		*((char *)top->head + size) = ch;
		size++;
	}
	printf("%d bytes read to %p:\n", (int)top->size, top->head);
	printf("%.*s\n", (int)top->size, (const char *)top->head);

	obs_stack_uninit(&obs);

	return 0;
}

void error(const char *func, OBS_status stat)
{
	fprintf(stderr, "%s: %s\n", func, obs_strstatus(stat));
	exit(EXIT_FAILURE);
}
